#![no_std]
#![feature(core_intrinsics)]

#[macro_use]
extern crate klee;
use klee::kassume;

use core::ptr;
use core::intrinsics::unchecked_div;

fn main() {
    let u = ksymbol!("u");
    kassume(u < 10);
    //kassert!(f1(u) == f1b(u));
    assert!(f1(u) == f1b(u));

    // unsafe {
    //     ptr::read_volatile(&f2(f1(u)));
    // }
}

// add 1 wrapping
fn f1(u: u8) -> u8 {
    let mut j = 0;
    for _i in 0..u {
        j += 1;
    }
    j
}

fn f1b(u: u8) -> u8 {
    u
}

fn f2(u: u8) -> u8 {
    unsafe { unchecked_div(100, u) }
}
