#![no_std]
#![feature(core_intrinsics)]

#[macro_use]
extern crate klee;

use core::ptr;
use core::intrinsics::unchecked_div;

fn main() {
    let u = ksymbol!("u");

    unsafe {
        ptr::read_volatile(&f2(f1(u)));
    }
}

fn f1(u: u8) -> u8 {
    u.wrapping_add(1)
}

fn f2(u: u8) -> u8 {
    unsafe { unchecked_div(100, u) }
}
